/**
 * jQuery Console
 * 
 * @file A jQuery plugin to create a non-interactive console within a page.
 * 
 * @author Ciarán Eaton
 * @version: 1.1.0
 * Project repository: https://github.com/EatonCiaran/jquery-console
 * 
 * Known to work with jQuery v3.x.x
 * 
 * @license Licensed under GPLv3
 * https://github.com/EatonCiaran/jquery-console#license
 * 
 * @copyright Copyright 2021 Ciarán Eaton
 * 
 */
!function($){$.fn.console=function(options){if(options.defaultLevel){let levels=settings.levels;if(options.levels&&(levels=options.levels),"number"==typeof options.defaultLevel&&(options.defaultLevel<0||options.defaultLevel>levels.length))throw"Invalid index value for defaultLevel: "+options.defaultLevel;throw"string"!=typeof options.defaultLevel||levels.contains(options.defaultLevel)?"Invalid type for defaultLevel: "+typeof options.defaultLevel:"Invalid name for defaultLevel: "+options.defaultLevel}let settings=$.extend({showTimestamp:!0,timestampOnLeft:!1,msgDirection:"down",history:1e4,timeout:0,fadeOutTime:400,levels:["emergency","alert","critical","error","warning","notice","info","debug"],defaultLevel:6,tagOddEven:!1},options),flags={scrollbarMoved:!1,odd:!0},$this=$(this);return this.each((function(){$this.addClass("jquery-console")})),this._getCssLevel=function(level){function getName(val,arr){return"number"==typeof val&&val>=0&&val<arr.length?arr[val]:!("string"!=typeof val||!arr.includes(val))&&val}const css_base="jquery-console-lvl-";let level_name=getName(0,settings.levels),name=getName(level,settings.levels);return name?level_name=name:void 0===level?level_name=getName(settings.defaultLevel,settings.levels):console.log("jQuery Console: Invalid severity level. Level: "+level),css_base+level_name},this._setScrollBar=function(){if("down"==settings.msgDirection&&!flags.scrollbarMoved){let h=$this.prop("scrollHeight"),c=$this.prop("clientHeight");$this.scrollTop(h-c)}},this._createEntry=function(msg,level){let $msgEntry=$("<div class='jquery-console-entry'></div>");$("<span class='jquery-console-msg'></span>").appendTo($msgEntry);let c_level=this._getCssLevel(level);$msgEntry.addClass(c_level),settings.tagOddEven&&(flags.odd?($msgEntry.addClass("jquery-console-odd"),$msgEntry.addClass(c_level+"-odd")):($msgEntry.addClass("jquery-console-even"),$msgEntry.addClass(c_level+"-even")),flags.odd=!flags.odd);let $msg=$msgEntry.children(".jquery-console-msg");if($msg.text(msg),settings.showTimestamp){let timestamp=new Date;timestamp=timestamp.toLocaleTimeString(),$("<span class='jquery-console-timestamp'></span>").appendTo($msgEntry),$msgEntry.children(".jquery-console-timestamp").text(timestamp),settings.timestampOnLeft?($msg.addClass("jquery-console-msg-ts-left"),$msgEntry.children(".jquery-console-timestamp").addClass("jquery-console-timestamp-left")):$msg.addClass("jquery-console-msg-ts")}return $msgEntry},this._adjustHeight=function($msgEntry){let $meg=$msgEntry.children(".jquery-console-msg");$msgEntry.height($meg.height())},this._insertMsg=function($msgEntry){if("up"==settings.msgDirection)$msgEntry.prependTo(this);else{flags.scrollbarMoved=!1;let h=$this.prop("scrollHeight")-$this.prop("clientHeight");$this.scrollTop()!=h&&(flags.scrollbarMoved=!0),$msgEntry.appendTo(this)}},this._cullHistory=function(){if(0==settings.history)return;let queueSize;$this.children(".jquery-console-entry").length>settings.history&&("up"==settings.msgDirection?$this.children(".jquery-console-entry").last().remove():$this.children(".jquery-console-entry").first().remove())},this._attachTimeout=function($msgEntry){if(settings.timeout>0){let timeout=settings.timeout,fadeout=settings.fadeOutTime;$msgEntry.delay(timeout).fadeOut(fadeout,(function(){$(this).remove()}))}},this.log=function(msg,level){let $msgEntry=this._createEntry(msg,level);this._insertMsg($msgEntry),this._attachTimeout($msgEntry),this._cullHistory(),this._setScrollBar(),this._adjustHeight($msgEntry)},this}}(jQuery);